// SPDX-License-Identifier: Apache-2.0
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
import { CommandHandler } from "../../../../../core/decorator/CommandHandlerDecorator";
import { lazyInject } from "../../../../../core/decorator/LazyInjectDecorator";
import TransactionService from "../../../../service/transaction/TransactionService";
import { UpdateMaturityDateCommand, UpdateMaturityDateCommandResponse } from "./UpdateMaturityDateCommand";
import ContractService from "../../../../service/contract/ContractService";
import ValidationService from "../../../../service/validation/ValidationService";
import { UpdateMaturityDateCommandError } from "./error/UpdateMaturityDateCommandError";
let UpdateMaturityDateCommandHandler = class UpdateMaturityDateCommandHandler {
    transactionService;
    contractService;
    validationService;
    constructor(transactionService, contractService, validationService) {
        this.transactionService = transactionService;
        this.contractService = contractService;
        this.validationService = validationService;
    }
    async execute(command) {
        try {
            const { maturityDate, securityId } = command;
            const handler = this.transactionService.getHandler();
            const securityEvmAddress = await this.contractService.getContractEvmAddress(securityId);
            await this.validationService.checkMaturityDate(securityId, maturityDate);
            const res = await handler.updateMaturityDate(securityEvmAddress, parseInt(maturityDate), securityId);
            return Promise.resolve(new UpdateMaturityDateCommandResponse(res.error === undefined, res.id));
        }
        catch (error) {
            throw new UpdateMaturityDateCommandError(error);
        }
    }
};
UpdateMaturityDateCommandHandler = __decorate([
    CommandHandler(UpdateMaturityDateCommand),
    __param(0, lazyInject(TransactionService)),
    __param(1, lazyInject(ContractService)),
    __param(2, lazyInject(ValidationService)),
    __metadata("design:paramtypes", [TransactionService,
        ContractService,
        ValidationService])
], UpdateMaturityDateCommandHandler);
export { UpdateMaturityDateCommandHandler };
